commit acdc767008460bf5e86a1bf39b43e8da7bd6e90d
Author: Andreas Metzler <ametzler@bebt.de>
Date:   Sat Dec 13 14:52:14 2025 +0000

    Build: linker invocation ordering
    
    Apparently some linkers are sensitive to positioning
    of library args in the commandline

diff --git a/src/scripts/Configure-Makefile b/src/scripts/Configure-Makefile
index 70dc886ab..b38fcd360 100755
--- a/src/scripts/Configure-Makefile
+++ b/src/scripts/Configure-Makefile
@@ -313,7 +313,13 @@ fi
 cp ../src/lookups/Makefile $look_mf_pre
 EGREP="$egrep" ../scripts/lookups-Makefile
 
-# make the Makefiles for routers, transports, auths and miscmods
+# Make the Makefiles for routers, transports, auths and miscmods
+#
+# Columns in the here-file:
+#  1		"class"		the subdir name to work in
+#  2		"classdef"	is a prefix on the driver name, used for pulling
+#  				construction data from Local/Makefile
+#  (remainder)	"names"		a list of driver names, in caps
 # An _ prefix on a name means the control in Local/Makefile is DISABLED_<name>
 #
 while read class classdef names
diff --git a/src/src/auths/Makefile b/src/src/auths/Makefile
index 6eab96a66..44ca8d8fb 100644
--- a/src/src/auths/Makefile
+++ b/src/src/auths/Makefile
@@ -31,8 +31,8 @@ auths.a:	$(OBJ)
 
 SO_FLAGS = -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) $(DLFLAGS)
 .c.so:;		@echo "$(CC) -shared $*.c"
-		$(FE)$(CC) $(SO_FLAGS) $(AUTH_$*_INCLUDE) $(AUTH_$*_LIBS) \
-			$*.c -o $@
+		$(FE)$(CC) $(SO_FLAGS) $(AUTH_$*_INCLUDE) $*.c $(AUTH_$*_LIBS) \
+			-o $@
 
 
 $(OBJ) $(MOD): $(HDRS)
diff --git a/src/src/lookups/Makefile b/src/src/lookups/Makefile
index 27ae3fe1e..560a5cba5 100644
--- a/src/src/lookups/Makefile
+++ b/src/src/lookups/Makefile
@@ -48,7 +48,9 @@ lookups.a:       avail_static_lookups.o $(OBJS)
 		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c
 
 .c.so:;          @echo "$(CC) -shared $*.c"
-		 $(FE)$(CC) $(LOOKUP_$*_INCLUDE) $(LOOKUP_$*_LIBS) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) $(DLFLAGS) $*.c -o $@
+		 $(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) \
+		 	$(LOOKUP_$*_INCLUDE) $(INCLUDE) $(DLFLAGS) $*.c \
+		 	$(LOOKUP_$*_LIBS) -o $@
 
 cdb.o cdb.so:           $(HDRS) cdb.c
 dbmdb.o dbmdb.so:       $(HDRS) dbmdb.c
diff --git a/src/src/miscmods/Makefile b/src/src/miscmods/Makefile
index e92c34941..2d44059ba 100644
--- a/src/src/miscmods/Makefile
+++ b/src/src/miscmods/Makefile
@@ -27,9 +27,9 @@ miscmods.a:	$(OBJ)
 		$(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c
 
 .c.so:;         @echo "$(CC) -shared $*.c"
-		$(FE)$(CC) $(SUPPORT_$*_INCLUDE) $(SUPPORT_$*_LIBS) \
-			-DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) \
-			$(DLFLAGS) $*.c -o $@
+		$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) \
+			$(SUPPORT_$*_INCLUDE) $(INCLUDE) $(DLFLAGS) $*.c \
+			$(SUPPORT_$*_LIBS) -o $@
 
 # Note that the sources from pdkim/ are linked into the build.../miscmods/ dir
 # by scripts/Makelinks.
@@ -68,10 +68,10 @@ dkim.o:
 # Similarly, we want a single .so for the dynamic-load module
 dkim.so:
 	@echo "$(CC) -shared dkim.c dkim_transport.c pdkim.c signing.c"
-	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) -o $@ \
-		$(SUPPORT_$*_INCLUDE) $(SUPPORT_$*_LIBS) \
-		$(CFLAGS) $(INCLUDE) $(TLS_INCLUDE) $(DLFLAGS) \
-		dkim.c dkim_transport.c pdkim.c signing.c
+	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) \
+		$(SUPPORT_$*_INCLUDE) $(INCLUDE) $(TLS_INCLUDE) $(DLFLAGS) \
+		dkim.c dkim_transport.c pdkim.c signing.c $(SUPPORT_$*_LIBS)  \
+		-o $@
 
 # spf_perl is special; Configure-Makefile asks for it but we actually
 # build resulting in a file named spf.so because the module-loading
@@ -81,9 +81,9 @@ dkim.so:
 
 spf_perl.so:
 	@echo "$(CC) -shared $*.c"
-	$(FE)$(CC) $(SUPPORT_SPF_PERL_INCLUDE) $(SUPPORT_SPF_PERL_LIBS) \
-			-DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) \
-			$(DLFLAGS) spf_perl.c -o spf.so
+	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) \
+		$(SUPPORT_SPF_PERL_INCLUDE) $(INCLUDE) $(DLFLAGS) \
+		spf_perl.c $(SUPPORT_SPF_PERL_LIBS) -o spf.so
 
 # DMARC
 dmarc.o dmarc_native.o:
@@ -96,10 +96,9 @@ dmarc.o dmarc_native.o:
 # dmarc_native is special in the same way as spf_perl
 dmarc.so dmarc_native.so:
 	@echo "$(CC) -shared $*.c dmarc_common.c"
-	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) -o dmarc.so \
-		$(SUPPORT_$*_INCLUDE) $(SUPPORT_$*_LIBS) \
-		$(CFLAGS) $(INCLUDE) $(TLS_INCLUDE) $(DLFLAGS) \
-		$*.c dmarc_common.c
+	$(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) \
+		$(SUPPORT_$*_INCLUDE) $(INCLUDE) $(TLS_INCLUDE) $(DLFLAGS) \
+		$*.c dmarc_common.c $(SUPPORT_$*_LIBS) -o dmarc.so
 
 # Compile instructions for static perl.o for when EXIM_PERL is set
 # Dynamic is managed all via scripts/Configure-Makefile
diff --git a/src/src/routers/Makefile b/src/src/routers/Makefile
index 1b2953d40..32515fcf8 100644
--- a/src/src/routers/Makefile
+++ b/src/src/routers/Makefile
@@ -26,7 +26,8 @@ routers.a:       $(OBJ)
 		 $(FE)$(CC) -c $(CFLAGS) $(INCLUDE) $*.c
 
 .c.so:;          @echo "$(CC) -shared $*.c"
-		 $(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) $(DLFLAGS) $*.c -o $@
+		 $(FE)$(CC) -DDYNLOOKUP $(CFLAGS_DYNAMIC) $(CFLAGS) $(INCLUDE) \
+			$(DLFLAGS) $*.c -o $@
 
 
 

